//  
//  (c) June 14, 2008 Vasily Volkov
//  

#include "FFT.h"
    
__global__ void FFT512_device( float2 *work )
{	
    work += (blockIdx.y * gridDim.x + blockIdx.x) * 512;
    
    int tid = threadIdx.x;
    int hi = tid>>3;
    int lo = tid&7;
    
    float2 a[8];
    __shared__ float smem[8*8*9];
    
    load( a, work + tid, 64 );
    
    FFT8( a );
    
    twiddle( a, tid, 512 );
    tranpose( a, &smem[hi*8+lo], 66, &smem[lo*66+hi], 8 );
    
    FFT8( a );
    
    twiddle( a, hi, 64 );
    tranpose( a, &smem[hi*8+lo], 8*9, &smem[hi*8*9+lo], 8, 0xE );
    
    FFT8( a );
    
    store( a, work + tid, 64 );
}	
    
extern "C" void FFT512( float2 *work, int batch )
{	
    FFT512_device<<< grid2D(batch), 64 >>>( work );
}	
