//  
//  (c) June 14, 2008 Vasily Volkov
//  

#include "FFT.h"

__global__ void FFT8_device( float2 *work )
{	
    work += (blockIdx.y * gridDim.x + blockIdx.x) * 512;
    
    int tid = threadIdx.x;
    
    float2 a[8];
    
    load( a, work + tid, 64 );
    
    FFT8( a );
    
    store( a, work + tid, 64 );
}	
    
extern "C" void FFT8( float2 *work, int batch )
{	
    FFT8_device<<< grid2D(batch/64), 64 >>>( work );
}	
